package nu.zoom.dsl.ast;

import nu.zoom.dsl.parser.EndpointsBaseVisitor;
import nu.zoom.dsl.parser.EndpointsParser;

import java.util.ArrayList;

public class EndpointsVisitorTransformer extends EndpointsBaseVisitor<EndpointsParser.DocumentContext> {
	private ArrayList<EndpointNode> endpoints = new ArrayList<>();
	private ArrayList<ConfigItemNode> config = new ArrayList<>();
	private ArrayList<CompoundTypeNode> dataTypes = new ArrayList<>();
	public EndpointsVisitorTransformer() {
	}

	@Override
	public EndpointsParser.DocumentContext visitConfigitem(EndpointsParser.ConfigitemContext ctx) {
		String configKey = ctx.configkey().IDENTIFIER().getText() ;
		String configValue = getText(ctx.configvalue()) ;
		this.config.add(new ConfigItemNode(configKey, configValue));
		return super.visitConfigitem(ctx) ;
	}

	@Override
	public EndpointsParser.DocumentContext visitCompoundType(EndpointsParser.CompoundTypeContext ctx) {
		return super.visitCompoundType(ctx);
	}

	@Override
	public EndpointsParser.DocumentContext visitEndpoint(EndpointsParser.EndpointContext ctx) {
		return super.visitEndpoint(ctx);
	}

	private String getText(EndpointsParser.ConfigvalueContext ctx) {
		String identifierText = (ctx.IDENTIFIER() != null) ? ctx.IDENTIFIER().getText() : "" ;
		String valueText = (ctx.VALUE() != null) ? ctx.VALUE().getText() : "" ;
		return identifierText + valueText;
	}
}
